//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****   JScript project dark_do_traverse_dark.jsp                                                      *****
//*****                                                                                                  *****
//*****   MANUAL                                                                                         *****
//*****                                                                                                  *****
//*****   Version 3.0 / 27 February, 2009                                                                *****
//*****                                                                                                  *****
//*****   Author V.I. Tsanev (vip20@cam.ac.uk)                                                           *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** ALL LINES IN THIS FILE HAVE TO START WITH TWO BACK SLASHES                                       *****
//*****                                                                                                  *****
//***** DO NOT MODIFY THIS FILE!!!                                                                       *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****   JScript project for prolonged collection of spectra in the manner :                            *****
//*****       dark, spectrum1, spectrum2, ... , dark                                                     *****
//*****       The sequence spectrum1, spectrum2, ...  has to be terminated by the user by pressing       *****
//*****       the STOP button in Script console window.                                                  *****
//*****       This script is suitable for traversing plumes without on-line retrieval.                   *****
//*****                                                                                                  *****
//*****       Script checks that the folder where user wants to stream recordet spectra doesn't          *****
//*****           exists. If yes, project will be terminated and thus overwriting of existed data        *****
//*****           will be avoided.                                                                       *****
//*****       Script performs a beep prompting the user to block the telescope                           *****
//*****       The user have 5 seconds to do this                                                         *****
//*****       Scripts collects first dark spectrum and saves it                                          *****
//*****       Script performs a beep prompting the user to un-block the telescope                        *****
//*****       Script record sequence spectrum1, spectrum2, ... until the user presses STOP button        *****
//*****       Script performs a beep prompting the user to block the telescope                           *****
//*****       The user have 5 seconds to do this                                                         *****
//*****       Scripts collects second dark spectrum and saves it                                         *****
//*****       Script performs a beep prompting the user to un-block the telescope, print on the output   *****
//*****       console names of output files and terminates                                               *****
//*****                                                                                                  *****
//*****   This script is suitable for traversing plumes.                                                 *****
//*****                                                                                                  *****
//*****   The script doesn't use AutoFileName option thus permitting to execute at the same time         *****
//*****       vispect.exe, i.e. to perform plumje search. Vispect.exe is available from                  *****
//*****       http://sourceforge.net/projects/vispect/                                                   *****
//*****                                                                                                  *****
//*****   Requires : (1) Executable beep.exe in the folder C:\work\                                      *****
//*****              (2) An non-existing folder (subfolder of c:\wor\ooi\) where to stream recorded      *****
//*****                  spectra                                                                         *****
//*****                                                                                                  *****
//*****   Outputs :  (1) Two dark spectra recorded before and after sequence spectrum1, spectrum2, ...   *****
//*****              (2) Sequence of spectra spectrum1, spectrum2,...                                    *****
//*****              (3) A ptotocol file in the folder where are streamed all spectra. This file can     *****
//*****                  provide rough estimate of the quality of recorded all spectra                   *****
//*****              (4) A list file in the folder where are streamed all spectra. This list serves as   *****
//*****                  input for the JScrip project correction_short.jsp                               *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  This project includes 5 JScrips :                                                               *****
//*****                                                                                                  *****
//*****    (1) dark_do_traverse_dark_manual.js                                                           *****
//******       the present file ; it may be excluded from project as it contais only comments, i.e.      *****
//*****        lines starting with two back slashes                                                      *****
//*****                                                                                                  *****
//*****    (2) dark_do_traverse_dark_initialization.js                                                   *****
//*****        the file where user has to input parameters describing collection process                 *****
//*****                                                                                                  *****
//*****    (3) dark_do_traverse_dark_variables.js                                                        *****
//*****        variables declaration - do not modify this file                                           *****
//*****                                                                                                  *****
//*****    (4) dark_do_traverse_dark_action.js                                                           *****
//*****        execution kernel - do not modify this file                                                *****
//*****                                                                                                  *****
//*****    (5) dark_do_traverse_dark_functions.js                                                        *****
//*****        collection of functions used - do not modify this file                                    *****
//*****                                                                                                  *****
//*****  The default position of the project and all assotiated files is the folder                      *****
//*****        c:\work\scripts\vollection_short\dark_do_traverse_dark\ .                                 *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** The user has to initialize of the project by modifying input in JSripts file                     *****
//*****     dark_do_traverse_dark_initialization.js                                                      *****
//*****                                                                                                  *****
//*****     (1) Individual exposure time in ms used to record an individual spectrum. This value may     *****
//*****         determined by the JScript project Optimum_IT.jsp                                         *****
//*****         var IndividualExpTime                                                                    *****
//*****                                                                                                  *****
//*****     (2) Number of individual spectra to co-add in order to record a spectrum. This value may     *****
//*****         determined by the JScript project Optimum_IT.jsp                                         *****
//*****         var NumberScans                                                                          *****
//*****                                                                                                  *****
//*****     (3) Common file name prefix used for nitialization of spectrum file names                    *****
//*****         ( see Note 2 below) - string, i.e. a word in quotation marks                             *****
//*****         var CommonSpectrumPrefix                                                                 *****
//*****                                                                                                  *****
//*****     (4) Common file name extension used for initialization of spectrum file names                *****
//*****         (see Note 2 below) - string, i.e. a word in quotation marks                              *****
//*****         var CommonSpectrumExtension                                                              *****
//*****                                                                                                  *****
//*****     (5) Number of digits used to assembly spectrum file names. This is part of initialization    *****
//*****         of spectrum file names (see Note 2 below)                                                *****
//*****         var NumberDigits                                                                         *****
//*****                                                                                                  *****
//*****     (6) Dark spectrum file name -  dark spectrum have the same extension as spectrum files -     *****
//*****         string, i.e. a word in quotation marks                                                   *****
//*****         var DarkSpectrumName                                                                     *****
//*****                                                                                                  *****
//*****     (7) Spectrometer type ( USB2000, USB2000+ or USB4000 are permitted, otherwise script         *****
//*****         will be terminated ) - string, i.e. a word in quotation marks                            *****
//*****         var spectrometerTYPE                                                                     *****
//*****                                                                                                  *****
//*****     (8) Spectrometer ID (e.g. USB2G11107) - string, i.e. a word in quotation marks               *****
//*****         var spectrometerID                                                                       *****
//*****                                                                                                  *****
//*****     (9) Short desription of thew experiment location - string, i.e. a word in quotation marks    *****
//*****         var locationID                                                                           *****
//*****                                                                                                  *****
//*****    (10) Short desription of the experiment - string, i.e. a word in quotation marks              *****
//*****         var experimentID                                                                         *****
//*****                                                                                                  *****
//*****    (11) Author - person performunt experiment (e.g. VIP20 )- string, i.e. a word in quotation    *****
//*****         marks                                                                                    *****
//*****         var authorID                                                                             *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****    NOTES:                                                                                        *****
//*****                                                                                                  *****
//*****         (1) User has to type his inputs only in file                                             *****
//*****             dark_do_traverse_dark_simple_initialization.js                                       *****
//*****             in lines not ending with five starts (*****)                                         *****
//*****                                                                                                  *****
//*****         (2) Example of spectrum file names when                                                  *****
//*****                 CommonSpectrumPrefix=spec,                                                       *****
//*****                 CommonSpectrumExtension=".std"                                                   *****
//*****                    and                                                                           *****
//*****                 NumberDigits=5                                                                   *****
//*****             spec00000.std, spec00001.std, spec00002.std,....                                     *****
//*****                                                                                                  *****
//*****         (3) The string CommonSpectrumExtension has to start with dot symbol (see Note 2)         *****
//*****                                                                                                  *****
//*****         (4) Example of spectrum file names when                                                  *****
//*****                 DarkSpectrumName="dark"                                                          *****
//*****                    and                                                                           *****
//*****                 CommonSpectrumExtension=".std"                                                   *****
//*****             dark1.std and dark2.std                                                              *****
//*****                                                                                                  *****
//*****         (5) The folder where script will streem recorded spectra, two dark spectra, the protocol *****
//*****             and list files will be assebled authomatically as                                    *****
//*****             "c:\work\ooi\CommonSpectrumPrefix. If CommonSpectrumPrefix="scan1" then the folder   *****
//*****             name will be                                                                         *****
//*****             c:\work\ooi\scan1                                                                    *****
//*****                                                                                                  *****
//*****         (6) Protocol file name is also assmble by using CommonSpectrumPrefix.                    *****
//*****             If CommonSpectrumPrefix="scan1" then the protocol file name will be                  *****
//*****             scan1_protocol.csv                                                                   *****
//*****                                                                                                  *****
//*****         (7) lIST file name is also assmble by using CommonSpectrumPrefix.                        *****
//*****             If CommonSpectrumPrefix="scan1" then the LIST file name will be                      *****
//*****             scan1_list.csv                                                                       *****
//*****                                                                                                  *****
//*****         (8) During the script execution Y-axis scale is fixed depending on used spectrometer     *****
//*****             and selected number of co-adds (max_count_ADC time number_of_co-adds) and user may   *****
//*****             track real signal variations. On the spectrum sheet is plotted currently recorded    *****
//*****             spectrum overlayed by first dark current (red line).                                 *****
//*****                                                                                                  *****
//*****         (9) The content of the list file may look as follows :                                   *****
//*****                                                                                                  *****
//*****                  178                                     - number of spectra in the list         *****
//*****                                                            NOTE: count starts with zero.         *****
//*****                  150                                     - individual IT                         *****
//*****                  5                                       - number of co-added spectra            *****
//*****                  lab                                     - location ID                           *****
//*****                  testing the script                      - experiment ID                         *****
//*****                  vip20                                   - Autors ID                             *****
//*****                  0 C:\work\ooi\tutu00000\tutu00000.std   - first spectrum in the list            *****
//*****                  .....................................                                           *****
//*****                  178 C:\work\ooi\tutu00000\tutu00178.std - last spectrum in the list             *****
//*****                                                          - intentionally empy line               *****
//*****                  Project dark_do_traverse_dark.jsp       - trade mark record                     *****
//*****                  Version 3.0 / 27 February 2009          - trade mark record                     *****
//*****                  Author V.I. Tsanev (vip20@cam.ac.uk     - trade mark record                     *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****    Version history:                                                                              *****
//*****                                                                                                  *****
//*****    v. 2.0   - sript trasformed to project                                                        *****
//*****             - improved manual                                                                    *****
//*****                                                                                                  *****
//*****    v. 3.0   - automatic naming of folder where are streamed recorded spatra                      *****
//*****             - list file introduced - now use of projest make_a_list_short.jsp is required        *****
//*****               for old data sets                                                                  *****
//*****             - automated naming of protocol and list files                                        *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
